Bug 111452 - Dull colors with kernel 5.2.0 on external monitors with intel-gfx
Summary: Dull colors with kernel 5.2.0 on external monitors with intel-gfx
Status: NEW
Alias: None
Product: DRI
Classification: Unclassified
Component: DRM/Intel (show other bugs)
Version: XOrg git
Hardware: x86-64 (AMD64) Linux (All)
: medium normal
Assignee: Intel GFX Bugs mailing list
QA Contact: Intel GFX Bugs mailing list
URL:
Whiteboard: Triaged, ReadyForDev
Keywords:
Depends on:
Blocks:
 
Reported: 2019-08-21 10:27 UTC by Bernd Buschinski
Modified: 2019-10-11 11:06 UTC (History)
2 users (show)

See Also:
i915 platform: SKL
i915 features: display/color management


Attachments
dmesg log with drm-tip f0d683fb459b73042451d5f17243e6bcb3cbfd98 and drm.debug=0x1e log_buf_len=4M (1.54 MB, text/x-log)
2019-10-11 08:40 UTC, Bernd Buschinski
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Bernd Buschinski 2019-08-21 10:27:56 UTC
With kernel 5.2.0 my colors on my external monitors are kind of dull.
Meaning the contrast seems lower and the gamma seems higher.
It worked fine with kernel 5.1.0.

It can be worked around with:

xrandr --output DP-1-1 --set 'Broadcast RGB' 'Full'
xrandr --output DP-1-2 --set 'Broadcast RGB' 'Full'

Only the external monitors (connected via laptop -> docking station -> display port) are affected. The laptop display is fine.


I started bisecting it and result is:

37aa52bff2bcd4377c0f747f730f3d436f2fe58e is the first bad commit
commit 37aa52bff2bcd4377c0f747f730f3d436f2fe58e
Author: Ville Syrjälä <ville.syrjala@linux.intel.com>
Date:   Tue Mar 26 16:25:51 2019 +0200

    drm/i915: Add broadcast RGB property for DP MST
    
    Add the "Broadcast RGB" property to MST connectors, and implement
    the same logic for it as we have in the SST code.
    
    v2: Extract and reuse intel_dp_limited_color_range()
    
    Cc: Ivan Vlk <ari@adyline.sk>
    Tested-by: Ivan Vlk <ari@adyline.sk>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=108821
    Signed-off-by: Ville Syrjälä <ville.syrjala@linux.intel.com>
    Reviewed-by: Jani Nikula <jani.nikula@intel.com> #v1
    Link: https://patchwork.freedesktop.org/patch/msgid/20190326142556.21176-1-ville.syrjala@linux.intel.com

 drivers/gpu/drm/i915/intel_dp.c     | 39 ++++++++++++++++++++++++-------------
 drivers/gpu/drm/i915/intel_dp_mst.c | 15 ++++++++++++--
 drivers/gpu/drm/i915/intel_drv.h    |  2 ++
 3 files changed, 40 insertions(+), 16 deletions(-)



CPU: Intel(R) Core(TM) i5-6300U CPU @ 2.40GHz
Laptop: Dell Latitude E7470
Software:
- xorg-server-1.20.5
- mesa-19.1.3
- libdrm-2.4.99


Kernel Bugzilla Link: https://bugzilla.kernel.org/show_bug.cgi?id=204351
Comment 1 Lakshmi 2019-08-21 12:29:30 UTC
(In reply to Bernd Buschinski from comment #0)
> With kernel 5.2.0 my colors on my external monitors are kind of dull.
> Meaning the contrast seems lower and the gamma seems higher.
> It worked fine with kernel 5.1.0.
> 
> It can be worked around with:
> 
> xrandr --output DP-1-1 --set 'Broadcast RGB' 'Full'
> xrandr --output DP-1-2 --set 'Broadcast RGB' 'Full'
> 
> Only the external monitors (connected via laptop -> docking station ->
> display port) are affected. The laptop display is fine.
> 
> 
> I started bisecting it and result is:
> 
> 37aa52bff2bcd4377c0f747f730f3d436f2fe58e is the first bad commit
> commit 37aa52bff2bcd4377c0f747f730f3d436f2fe58e
> Author: Ville Syrjälä <ville.syrjala@linux.intel.com>
> Date:   Tue Mar 26 16:25:51 2019 +0200
> 
>     drm/i915: Add broadcast RGB property for DP MST
>     
>     Add the "Broadcast RGB" property to MST connectors, and implement
>     the same logic for it as we have in the SST code.
>     
>     v2: Extract and reuse intel_dp_limited_color_range()
>     
>     Cc: Ivan Vlk <ari@adyline.sk>
>     Tested-by: Ivan Vlk <ari@adyline.sk>
>     Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=108821
>     Signed-off-by: Ville Syrjälä <ville.syrjala@linux.intel.com>
>     Reviewed-by: Jani Nikula <jani.nikula@intel.com> #v1
>     Link:
> https://patchwork.freedesktop.org/patch/msgid/20190326142556.21176-1-ville.
> syrjala@linux.intel.com
> 
>  drivers/gpu/drm/i915/intel_dp.c     | 39
> ++++++++++++++++++++++++-------------
>  drivers/gpu/drm/i915/intel_dp_mst.c | 15 ++++++++++++--
>  drivers/gpu/drm/i915/intel_drv.h    |  2 ++
>  3 files changed, 40 insertions(+), 16 deletions(-)
> 
> 
> 
> CPU: Intel(R) Core(TM) i5-6300U CPU @ 2.40GHz
> Laptop: Dell Latitude E7470
> Software:
> - xorg-server-1.20.5
> - mesa-19.1.3
> - libdrm-2.4.99
> 
> 
> Kernel Bugzilla Link: https://bugzilla.kernel.org/show_bug.cgi?id=204351

@Ville Any comments?
Comment 2 Ville Syrjala 2019-08-21 14:22:11 UTC
Sounds like a broken display that doesn't respect the CEA range bit in MSA. Either that or someone has manually tweaked the "black level" etc. setting on the display to expect full range output always.
Comment 3 Bernd Buschinski 2019-08-23 08:49:01 UTC
What does this actually mean? I hit the "factory reset" on the monitor setting multiple times now.
All color profiles are set to Standard/RGB.

So what can I actually do? Deal with it? How can I help you to debug this further?

From a very "naive" user point of view this is simply a regression, as it used to work fine with kernel <5.2.

Monitor: Dell P2314H (connected via display port)
Comment 4 Bernd Buschinski 2019-10-07 17:34:53 UTC
As this monitor is used a lot in our company (and more people are upgrading their systems) the problem is getting worse by the day.

Can I somehow help you to solve this issue?
Comment 5 Bernd Buschinski 2019-10-07 17:35:37 UTC
And yes, this problem still exists with Kernel 5.3.4
Comment 6 Jani Saarinen 2019-10-07 18:46:01 UTC
Can you try drm-tip if fixed there already? 
On there I can see revert of "drm/i915: Fix DP-MST crtc_mask"
Also pulled to drm-intel-fixes already.
Comment 7 Bernd Buschinski 2019-10-08 08:38:56 UTC
I tested drm-tip f0d683fb459b73042451d5f17243e6bcb3cbfd98
but the issue is still present.
Comment 8 Lakshmi 2019-10-10 08:16:37 UTC
(In reply to Bernd Buschinski from comment #7)
> I tested drm-tip f0d683fb459b73042451d5f17243e6bcb3cbfd98
> but the issue is still present.

 Can you please attach the full dmesg from boot with kernel parameters drm.debug=0x1e log_buf_len=4M ?
Comment 9 Bernd Buschinski 2019-10-11 08:40:53 UTC
Created attachment 145700 [details]
dmesg log with drm-tip f0d683fb459b73042451d5f17243e6bcb3cbfd98 and drm.debug=0x1e log_buf_len=4M


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.